#include "palsol.h"
#include <iomanip>

// A SMALL DEMONSTRATION EXAMPLE

int main()
{ 
 /* --------- DATA PREPARATION-----------*/
  double matm[5]={1,1,1,1,1};	//Matrix M
  int	nnzm = 5;
  int	rowindm[5]={1,2,3,4,5};
  int	colptrm[6]={1,2,3,4,5,6};
  
  double matc[1]={0.1}; 	// matrix K
  int	nnzc = 1;
  int	rowindc[1]={1};
  int	colptrc[6]={1,2,2,2,2,2};
  
  double matk[5]={4,3,2,1,0};	// matrix K
  int	nnzk = 5;
  int	rowindk[5]={1,2,3,4,5};
  int	colptrk[6]={1,2,3,4,5,6};

 /*-----------Step 1: DEFINE PAL MATRICES-----------*/
  int nev	= 2; 						// Number of required eigenvalues.
  int  p	= 1;  						// Pade order.
  COMPLEX	sigma(0.0,2.0);    		// Shift sigma = 2i.

  int n 	= 5;
  PALMatrix M(n, n, nnzm, matm, rowindm, colptrm);
  PALMatrix C(n, n, nnzc, matc, rowindc, colptrc);
  PALMatrix K(n, n, nnzk, matk, rowindk, colptrk);

  /*-----------Step 2: PROBLEM SET UP-------------*/ 
  PALSol LowRankQEP(p, sigma, nev, M, C, K);
  
  /*-----------Step 3: SOLVE THE PROBLEM-----------*/ 
  LowRankQEP.EigComp();	// Solve the QEP.

  LowRankQEP.PrintEig( 8);	// Output the results.
  
  return 0;
}
